
package de.ivu.elect.presentation.personenpruefung.menu;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.personenpruefung.boundary.PersonenKonfliktEdit;
import de.ivu.elect.business.personenpruefung.boundary.PersonenPruefungStarter;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.jee.faces.FacesContextUtil;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;


import static java.util.Collections.singletonList;

public abstract class AbstractPersonenKonfliktPersonenregisterAbgleichRestartMenuItemEntry extends AbstractMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient PersonenKonfliktEdit personenKonfliktEdit;

  @Inject
  private transient PersonenPruefungStarter personenPruefungStarter;

  protected AbstractPersonenKonfliktPersonenregisterAbgleichRestartMenuItemEntry() {
    super();
  }

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(getUseCasePermission());
  }

  protected abstract UseCasePermission getUseCasePermission();

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return KEINE_GEBIET_SECURITY;
  }

  @Override
  public boolean isDisabledInternal() {
    return false;
  }

  @Override
  public String getTargetViewId() {
    // NOTE, dass kein Redirect erfolgen soll, sondern die doAction Methode ausgeführt werden muss.
    return null;
  }

  @Override
  public String doAction() {
    resetPersonenKonfliktPersonenregisterAbgleichManuellZuPruefen();
    startPersonenPruefung();

    return FacesContextUtil.getCurrentViewId();
  }

  private void resetPersonenKonfliktPersonenregisterAbgleichManuellZuPruefen() {
    personenKonfliktEdit.resetPersonenKonfliktPersonenregisterAbgleichManuellZuPruefen();
  }

  protected void startPersonenPruefung() {
    personenPruefungStarter.startePersonenPruefung();
  }

  @Override
  public String getLabelKey() {
    return "personen.konflikt.personenregister.abgleich.restart.menu.item.label";
  }

  @Override
  protected List<String> getAdditionalTopicViewIds() {
    return singletonList("");
  }
}
